﻿Imports System.Drawing

Namespace Strokes

    Public Class StandardStroke : Inherits Plugin.StrokeModifier
        Private Const _numOfPoints = 4
        Private Const _strength = 30
        Dim _strokePoints As List(Of Api.StrokePoint) = New List(Of Api.StrokePoint)

        Public Overrides Function GetRevisedStrokePoints(ByVal strokePoint As Api.StrokePoint) As List(Of Api.StrokePoint)
            GetRevisedStrokePoints = New List(Of Api.StrokePoint)
            If Me._strokePoints.Count = 0 OrElse strokePoint.Pressure = 0 Then
                Me._strokePoints.Add(strokePoint)
                Me._strokePoints.Add(strokePoint)
            ElseIf Math.Sqrt((strokePoint.X - Me._strokePoints.Last().X) ^ 2 + (strokePoint.Y - Me._strokePoints.Last().Y) ^ 2) > _strength Then
                Me._strokePoints.Add(strokePoint)
            End If
            If Me._strokePoints.Count >= _numOfPoints Then
                GetRevisedStrokePoints.AddRange(Me.Revise(Me._strokePoints.GetRange(0, _numOfPoints)))

                Me._strokePoints.RemoveAt(0)
            End If
            Debug.Assert(Me._strokePoints.Count <= _numOfPoints)
        End Function

        Private Function Revise(ByVal pt As List(Of Api.StrokePoint)) As List(Of Api.StrokePoint)
            Revise = New List(Of Api.StrokePoint)

            Dim x0, x1, y0, y1, xx0, yy0, xx1, yy1
            x0 = pt(1).X : y0 = pt(1).Y
            x1 = pt(2).X : y1 = pt(2).Y
            Dim pressure0 = pt(1).Pressure
            Dim pressure1 = pt(2).Pressure
            xx0 = (pt(2).X - pt(0).X) / 2 : yy0 = (pt(2).Y - pt(0).Y) / 2
            xx1 = (pt(3).X - pt(1).X) / 2 : yy1 = (pt(3).Y - pt(1).Y) / 2

            Dim x, y, x_, y_, t, p
            x = 0 : y = 0 : p = pressure0
            For t = 0 To 1 Step 0.05 ' FIXME:"Step ..." 結果が一定の間隔になるように。さもなくば座標間を線形補間。
                x_ = x
                y_ = y
                x = (2 * x0 - 2 * x1 + xx0 + xx1) * (t ^ 3) + (-3 * x0 + 3 * x1 - 2 * xx0 - xx1) * (t ^ 2) + xx0 * t + x0
                y = (2 * y0 - 2 * y1 + yy0 + yy1) * (t ^ 3) + (-3 * y0 + 3 * y1 - 2 * yy0 - yy1) * (t ^ 2) + yy0 * t + y0

                Revise.Add(New Plugin.StrokePoint(New PointF(x, y), p))

                p = pressure0 + (pressure1 - pressure0) * t
            Next
        End Function

    End Class

End Namespace
