﻿Public Class App
    Shared _me As App = Nothing
    Public Const Button_Commands As Integer = 0
    Public Const Button_Strokes As Integer = 1

    Public Shared ReadOnly Property Instance() As App
        Get
            If App._me Is Nothing Then
                App._me = New App
            End If
            Instance = App._me
        End Get
    End Property

    Private Sub New()
        'With Me
        '    Dim tablet = WindowsApplication1.Tablet.Instance("tablet2")
        '    Dim invoker = New DrawFreehandLine(tablet)
        '    Dim commands = tablet.Commands(invoker.GetType())
        '    commands.Add(New WindowsApplication1.Plugin.Commands.NullBrushCommand)
        '    tablet.Commands(invoker.GetType()) = commands
        '    tablet.StrokeModifier(invoker.GetType()) = New WindowsApplication1.Plugin.Strokes.NullStroke
        'End With

        With Me
            Dim tablet = WindowsApplication1.Tablet.Instance("tablet1")
            Dim invoker = New DrawFreehandLine(tablet)
            Dim commands = tablet.Commands(invoker.GetType())
            commands.Add(New WindowsApplication1.Plugin.Commands.NullBrushCommand)
            tablet.Commands(invoker.GetType()) = commands
            tablet.StrokeModifier(invoker.GetType()) = New Plugin.Strokes.NullStroke
        End With

        ' UNDONE:
        With Me
            Dim files = System.IO.Directory.GetFiles(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, "Plugin"), "*.dll", IO.SearchOption.AllDirectories).GetEnumerator()
            Do While files.MoveNext()
                Debug.Print("DLL:" & DirectCast(files.Current, String))
                Dim asm = Reflection.Assembly.LoadFrom(DirectCast(files.Current, String))
                Dim types = asm.GetTypes().GetEnumerator()
                Do While types.MoveNext()
                    Dim t = DirectCast(types.Current(), Type)
                    Debug.Print("Found:" & t.FullName)
                    Dim commands = New List(Of Api.Command)
                    Dim strokes = New List(Of Api.StrokeModifier)
                    Dim tag = New List(Of Object)
                    tag.Add(commands)
                    tag.Add(strokes)
                    Debug.Assert(tag(Button_Commands) Is commands)
                    Debug.Assert(tag(Button_Strokes) Is strokes)
                    If t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.Command,WindowsApplication1.Plugin", True, True)) Then
                        Debug.Print("Loaded (Command):" & t.FullName)
                        Dim cmd = asm.CreateInstance(t.FullName)
                        Dim b = New Button()
                        With b
                            .Tag = tag
                            .Text = t.Name
                            .AutoSizeMode = AutoSizeMode.GrowAndShrink
                            .AutoSize = True
                            .Dock = DockStyle.Top
                        End With
                        commands.Add(cmd)
                        Debug.Assert(b.Tag(Button_Commands).item(0) Is cmd)
                        MainForm._palette1.Regist(b)
                    ElseIf t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.StrokeModifier,WindowsApplication1.Plugin", True, True)) Then
                        Debug.Print("Loaded (StrokeModifier):" & t.FullName)
                        Dim s = asm.CreateInstance(t.FullName)
                        Dim b = New Button()
                        With b
                            .Tag = tag
                            .Text = t.Name
                            .AutoSizeMode = AutoSizeMode.GrowAndShrink
                            .AutoSize = True
                            .Dock = DockStyle.Top
                        End With
                        strokes.Add(s)
                        Debug.Assert(b.Tag(Button_Strokes).item(0) Is s)
                        MainForm._palette1.Regist(b)
                    End If
                Loop
            Loop
            With Me
                Dim commands = New List(Of Api.Command)
                Dim strokes = New List(Of Api.StrokeModifier)
                Dim tag = New List(Of Object)
                tag.Add(commands)
                tag.Add(strokes)
                commands.Add(New Plugin.Commands.NullBrushCommand)
                strokes.Add(New Plugin.Strokes.NullStroke)
                Dim b = New Button()
                With b
                    .Tag = tag
                    .Text = "* Default *"
                    .AutoSizeMode = AutoSizeMode.GrowAndShrink
                    .AutoSize = True
                    .Dock = DockStyle.Top
                End With
                MainForm._palette1.Regist(b)
            End With

            'Dim tablet = WindowsApplication1.Tablet.Instance("tablet2")
            'Dim invoker = New DrawFreehandLine(tablet)
            'Dim files = System.IO.Directory.GetFiles(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, "Plugin"), "*.dll", IO.SearchOption.AllDirectories).GetEnumerator()
            'Do While files.MoveNext()
            '    Debug.Print("DLL:" & DirectCast(files.Current, String))
            '    Dim commands = tablet.Commands(invoker.GetType())
            '    Dim stroke = tablet.StrokeModifier(invoker.GetType())
            '    Dim a = Reflection.Assembly.LoadFrom(DirectCast(files.Current, String))
            '    Dim types = a.GetTypes().GetEnumerator()
            '    Do While types.MoveNext()
            '        Dim t = DirectCast(types.Current(), Type)
            '        Debug.Print("Found:" & t.FullName)
            '        If t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.Command,WindowsApplication1.Plugin", True, True)) Then
            '            Debug.Print("Loaded (Command):" & t.FullName)
            '            commands.Add(a.CreateInstance(t.FullName))
            '        ElseIf t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.StrokeModifier,WindowsApplication1.Plugin", True, True)) Then
            '            Debug.Print("Loaded (StrokeModifier):" & t.FullName)
            '            stroke = a.CreateInstance(t.FullName)
            '        End If
            '    Loop
            '    tablet.Commands(invoker.GetType()) = commands
            '    tablet.StrokeModifier(invoker.GetType()) = stroke
            'Loop
        End With
    End Sub
End Class
