﻿Public MustInherit Class StrokeModifier : Implements Api.StrokeModifier
    Dim _strokePoint As Api.StrokePoint

    Public Overridable Function GetRevisedStrokePoints(ByVal strokePoint As Api.StrokePoint) As List(Of Api.StrokePoint) Implements Api.StrokeModifier.GetRevisedStrokePoints
        If Me._strokePoint Is Nothing Then
            Dim l = New List(Of Api.StrokePoint)
            l.Add(strokePoint)
            GetRevisedStrokePoints = l
        Else
            Dim l = New List(Of Api.StrokePoint)
            l.Add(Me._strokePoint)
            l.Add(strokePoint)
            GetRevisedStrokePoints = Me.Revise(l)
        End If
        Me._strokePoint = strokePoint
    End Function

    Private Function Revise(ByVal strokePoints As List(Of Api.StrokePoint)) As List(Of Api.StrokePoint)
        Revise = New List(Of Api.StrokePoint)
        If strokePoints.Count > 0 Then
            Revise.Add(strokePoints(0))
            Dim p_ = strokePoints(0)
            Dim _bw = p_.Pressure
            For Each p In strokePoints.GetRange(1, strokePoints.Count - 1)
                Dim ps As System.Drawing.PointF = p_.Location
                Dim pe As System.Drawing.PointF = p.Location
                Dim yx As Boolean = Math.Abs(pe.X - ps.X) < Math.Abs(pe.Y - ps.Y)
                If yx Then
                    Swap(ps.X, ps.Y)
                    Swap(pe.X, pe.Y)
                End If
                Dim a, k
                a = IIf((pe.X - ps.X) <> 0, (pe.Y - ps.Y) / (pe.X - ps.X), 1)
                k = ps.Y - a * ps.X
                Dim bw_ = p.Pressure
                Dim sign As Integer = IIf(ps.X <= pe.X, 1, -1)
                Dim numLoops As Integer = Math.Max(Math.Ceiling(Math.Abs(pe.X - ps.X) / 1), 1)
                Dim count As Integer = 0
                For x = ps.X To pe.X Step 1 * sign
                    Dim y = a * x + k

                    If yx Then Swap(x, y)

                    Dim pp = New StrokePoint(New System.Drawing.Point(x, y), _bw + (bw_ - _bw) / numLoops * count)
                    'Debug.Print("pp:" & pp.Pressure & " : " & _bw & " + (" & bw_ & " - " & _bw & ") / " & numLoops & " * " & count)
                    Revise.Add(pp)

                    If yx Then Swap(x, y)

                    count = count + 1
                Next
                _bw = bw_
                p_ = p
            Next
        End If
    End Function

    Protected Sub Swap(ByRef a, ByRef b)
        Dim c
        c = a
        a = b
        b = c
    End Sub

End Class
